class BaseMigrationNodeObjecttypes extends BaseMigrationNodeData

	getDisplayText: ->
		$$("base.migration.node.objecttype.text")

	getActionPane: ->
		pane = @getActionPaneBase()
		pane

	getActionFields: ->
		ots = []
		for c in @children
			acl_count = c.getData()._acl.length
			if acl_count == 0
				continue

			ots.push(c.getDisplayText() + " (" + acl_count + ")")

		[
			type: CUI.Options
			name: "migrate"
			form:
				label: $$("base.migration.node.objecttypes.migrate.label")
			options: [
				text: if ots.length != 0 then ots.join(", ") else $$("base.migration.node.objecttype.empty-selection")
				disabled: ots.length == 0
				value: "acl"
			]
		,
			type: CUI.Options
			name: "mode"
			radio: true
			form:
				label: $$("base.migration.node.objecttype.mode.label")
			options: [
				text: $$("base.migration.node.objecttype.mode.replace")
				value: "replace"
			,
				text: $$("base.migration.node.objecttype.mode.add")
				value: "add"
			]
		]


	checkMigrateButton: ->
		@__migrateBtn.disable()
		if @__actionData.migrate.length == 0
			return
		@__migrateBtn.enable()
		return

	migrate: (ev, action_data) ->

		dfr = new CUI.Deferred()

		idx = 0
		next_ot_node = =>
			if idx == @children.length
				dfr.resolve()
				return

			ot_node = @children[idx]
			ret = ot_node.migrate(ev, action_data)
			ret
			.done =>
				idx++
				next_ot_node()
			.fail =>
				dfr.reject()

		next_ot_node()

		dfr.promise()

